/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  MCXINFO.C    EXEMPLE D'UTILISATION DES FONCTIONS IOCTL         %%
%%               DU DRIVER MCX POUR WINDOWS 95                     %%
%%                                                                 %%
%%  DESCRIPTION :                                                  %%
%%                                                                 %%
%%  Ce programme trs simple est destin  illustrer l'utilisation %%
%%  des commandes DeviceIoControl IOCTL_SERIAL_INFOBOARD,          %%
%%  IOCTL_SERIAL_INFOCHAN et IOCTL_SERIAL_CMD_AUTO du driver de    %%
%%  de la carte MCX                                                %%
%%                                                                 %%
%%  MCXINFO ouvre le port COM5 et affiche des informations         %%
%%  concernant la carte MCX associe  ce port, des informations   %%
%%  sur le port spcifi dans la ligne de commande, puis envoie    %%
%%  une commande TFREE  ce port.                                  %%
%%                                                                 %%
%%  Rev 1.00    Microsoft C 4.0                ACKSYS 1998 - ERL  %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

#define MCXWIN95

#include <stdio.h>
#include <conio.h>
#include <windows.h>
#include <vmm.h>
#include <string.h>

#pragma pack(4)
#include "MCC_MCX.H"
#pragma pack(2)
#include "MCXCTL.H"
#pragma pack()


// DEFINITIONS

#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))


// PROTOTYPE DES FONCTIONS :

BYTE SendCommande(BYTE canal, BYTE CodeCommande, BYTE *rdata);

void main(int c, char **v)
{

    HANDLE      hVxD= 0;            // Handle
    DWORD       cbRet, rc;          // Code retour
    WORD        writeparm[4];       // Pour le passage des infos au driver
    BOARDINFO   brdinf;             // Structure pour les infos carte
    CANALINFO   cinfo;              // Structure pour les infos canal
    PMCC_CMD    cmdbuf;             // Structure pour le passage de commande
    BYTE        file[20];           // Tampon pour le nom du port
    BYTE        canal;

    char parity[5][15]= {"sans parit", "parit impaire", "parit paire",
                    	 "parit mark", "parit space"};
    char stop[3][10]= {"1 stop","1,5 stops","2 stops"};
    char mode[9][9]= {"RS232","RS422","RS485","RS449","V35","V36",
                       "EIA530","EIA530-A","TRISTATE"};

    if( c != 2)
    {
        printf("Usage: %s n\nExemple pour COM5 : %s 5\n",v[0],v[0]);
        return;
    }
    strcpy(file,"COM");
    strcat(file,v[1]);
    printf("OUVERTURE PORT COM5\n");

    hVxD = CreateFile("\\\\.\\COM5", 0,0,0,0,0,0);

    if ( hVxD == INVALID_HANDLE_VALUE )
    {
        cbRet = GetLastError();
        printf("Impossible d'ouvrir le VxD, Code erreur: %lx\n",cbRet);
        return;
    }

    // LECTURE DES INFO CARTE : FUNCTION IOCTL_SERIAL_INFOBOARD

    printf("- FONCTION IOCTL_SERIAL_INFOBOARD : LECTURE DES INFOS CARTE N1\n");
    writeparm[0]=1;                     // Carte n1
    writeparm[1]=0;                     // Flag 0
    writeparm[2]= sizeof(brdinf);       // Nombre d'octets  lire
    if (rc= DeviceIoControl(hVxD, IOCTL_SERIAL_INFOBOARD,
                (LPVOID)&writeparm, sizeof(writeparm),
                (LPVOID)&brdinf, sizeof(brdinf),
                &cbRet, NULL) )
    {
        if (brdinf.card_stat & MCCBOARD)
            printf("  Carte MCC %d ports\n",brdinf.chanb);
        else
        {
            printf("  Carte MCX");
            if (brdinf.card_stat & LITE570)
                printf("-lite/570");
            printf(" %s/%dMhz%s %d ports, %d Mo, ",
                	(brdinf.config & 0x40) ? "486SLC" : "386SX",
                    brdinf.frequency,
                    (brdinf.config & 0x80) ? " + 387SX," : ",",
                    brdinf.chanb,
                    brdinf.config & 0xF);
	        if (brdinf.config & 0x10)
                printf ("Double oscillateur\n");
        	else
                printf ("Simple oscillateur\n");
        	if (brdinf.config & 0x20)
                printf ("  Alimentation installe\n");
            printf("  Adresse :  %X, IRQ : %d\n",
                    brdinf.mb_addr,brdinf.mcx_irq);
        	if (brdinf.card_stat & MULTIPRO)
                printf("  Mode Multiprotocole ");
        }
        printf("  Firmware rev %d.%d\n\n",brdinf.firmware/16,
                	brdinf.firmware & 0xF);
    }
    else
    {
    	printf("Ce priphrique ne supporte pas l'API demande\n");
    }

    // LECTURE DES INFOS CANAL : FONCTION IOCTL_SERIAL_INFOCHAN

    printf("- FONCTION IOCTL_SERIAL_INFOCHAN : LECTURE DES INFOS PORT ");
    printf("%s\n",file);
    cinfo.PortId= 0x00;
    strcpy(cinfo.PortName,&file);
    rc= DeviceIoControl(hVxD, IOCTL_SERIAL_INFOCHAN,
                (LPVOID)&cinfo, sizeof(CANALINFO),
                (LPVOID)&cinfo, sizeof(CANALINFO),
                &cbRet, NULL );

    if (cinfo.PortId == 0)
    {
	    printf("LE PORT %s N'EST PAS OUVERT\n",file);
        exit(0);
    }

    printf("  Port %s, carte n%d, canal n%d\n",cinfo.PortName,
                        cinfo.Carte+1,cinfo.Canal);
    printf("  BP %d Hz, RxSize: %d, TxSize: %d, Mode: %s\n",cinfo.BpClk,
                        cinfo.RxSize,cinfo.TxSize,mode[cinfo.OpMode]);
    printf("  %d bps, %d bits, %s, %s\n", cinfo.BaudRate, cinfo.ByteSize,
                        parity[cinfo.Parity],stop[cinfo.StopBits]);
    printf("  mcr= %X, msr= %X, RxEnb= %x\n",cinfo.Mcr,cinfo.Msr,cinfo.RxEnb);
    printf("  Rx Trigg= %x, Tx trigg= %x, HndShkMode= %x\n\n",
                    	cinfo.RecvTrigger,cinfo.SendTrigger,cinfo.HndShkMode);

    canal= cinfo.Canal;

    // ENVOI D'UNE COMMANDE TFREE SUR COM5
    printf("- ENVOI COMMANDE TFREE       ");

    cmdbuf= malloc(sizeof(mcc_cmd) + 16);

    cmdbuf->Cb.opcode= TFREE;
    cmdbuf->Cb.par[0]=1;
    cmdbuf->Cb.length= 2;

    rc= DeviceIoControl(hVxD, IOCTL_SERIAL_CMD_AUTO,
                (LPVOID)cmdbuf, sizeof(cmdbuf),
                (LPVOID)cmdbuf, sizeof(cmdbuf),
                &cbRet, NULL );

    printf("DATA= 0x%4x\n",*(PWORD)cmdbuf->Data);

    // ENVOI D'UNE COMMANDE RSMDE SUR LE PORT SPECIFIE
    printf("- ENVOI COMMANDE RSMDE:422   ");

    cmdbuf->Cb.opcode= RSMDE;
    cmdbuf->Cb.par[0]=canal;
    cmdbuf->Cb.par[1]=1;
    cmdbuf->Cb.length=3;

    rc= DeviceIoControl(hVxD, IOCTL_SERIAL_CMD,
                (LPVOID)cmdbuf, sizeof(cmdbuf),
                (LPVOID)cmdbuf, sizeof(cmdbuf),
                &cbRet, NULL );
    puts("OK");

    CloseHandle(hVxD);

}
